import 'package:flutter/material.dart';

void main() {
  runApp(const MyApp());
}

class MyApp extends StatelessWidget {
  const MyApp({super.key});

    @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: 'Flutter Demo',
      theme: ThemeData(
        colorScheme: ColorScheme.fromSeed(seedColor: Colors.deepPurple),
        useMaterial3: true,
      ),
      home: const MyHomePage(title: 'Lab3'),
    );
  }
}

class MyHomePage extends StatefulWidget {
  const MyHomePage({super.key, required this.title});

  final String title;

  @override
  State<MyHomePage> createState() => _MyHomePageState();
}

class _MyHomePageState extends State<MyHomePage> {
  final Color _color = Colors.orangeAccent;

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        backgroundColor: _color,
        title: Text(widget.title),
      ),
      body: const MyWidget(),
    );
  }
}

class _CardData{
  final String text;
  final String descriptionText;
  final IconData icon;
  final String? imageUrl;

  _CardData(
    this.text,  {
    required this.descriptionText,
    this.icon= Icons.ac_unit_outlined,
    this.imageUrl,
  });
}

class MyWidget extends StatelessWidget {
  const MyWidget({super.key}); // ключи

  @override
  Widget build(BuildContext context) {
    final data = [
      _CardData(
        'mew',
        descriptionText: 'hehehehe',
        icon: Icons.account_balance,
        imageUrl:
          'https://sun165-1.userapi.com/impg/j-ZnE55SoxJuxbDst9BoJrS__UXocF4da6lUPQ/5XrJ_S-0R9o.jpg?size=810x1080&quality=95&sign=45abca51d4f25317989df7d370630b69&type=album'
      ),
      _CardData(
        'Hello',
        descriptionText: 'miumiumiu',
        icon: Icons.adb_outlined,
        imageUrl:
          'https://sun34-1.userapi.com/impg/5IEbax8DvqadOTjsd2QvO_4K9GLbvU2uPcJkkA/0CGHMQActFU.jpg?size=968x1080&quality=95&sign=6fcae468d5ca12aab4397106bc5df1ad&type=album'
      ),
      _CardData(
        'miu',
        descriptionText: 'lalala',
        icon: Icons.ac_unit_outlined,
        imageUrl:
          'https://sun165-2.userapi.com/impg/rPyrll39KOW1jawF0jNJfGYQQ0czceUbELeEjQ/xwhmmbiYKSw.jpg?size=810x1080&quality=95&sign=3d1324a18563eda6ad0cb10a751860dd&type=album'
      ),
    ];

    return Center(
      child: SingleChildScrollView(
          child: Column(
            mainAxisAlignment: MainAxisAlignment.center,
            children: data.map((e) => _Card.fromData(e)).toList(),
        )
      ),
    );
  }
}

class _Card extends StatelessWidget {
  final String text;
  final String descriptionText;
  final IconData icon;
  final String? imageUrl;

  const _Card(
      this.text, {
        this.icon = Icons.ac_unit_outlined,
        required this.descriptionText,
        this.imageUrl,
  });

  factory _Card.fromData(_CardData data) => _Card(
      data.text,
      descriptionText: data.descriptionText,
      icon: data.icon,
    imageUrl: data.imageUrl,
  );


  @override
  Widget build(BuildContext context) {
    return Container(
        margin: const EdgeInsets.only(top: 16),
        padding: const EdgeInsets.all(16),
        decoration: BoxDecoration(
        color: Colors.orangeAccent[100],
        borderRadius: BorderRadius.circular(20),
        border: Border.all(
          color: Colors.deepOrange,
          width: 2
        )
      ),
      child: Row(
        mainAxisAlignment: MainAxisAlignment.spaceBetween,
        crossAxisAlignment: CrossAxisAlignment.start,
        children: [
          SizedBox(
            height: 140,
            width: 100,
            child: Image.network(
              imageUrl ?? '',
              errorBuilder: (_, __, ___) => const Placeholder(),
            )
          ),
          Expanded (
            child: Padding(
              padding: const EdgeInsets.only(left: 8.0),
              child: Column(
                crossAxisAlignment: CrossAxisAlignment.start,
                children: [
                  Text(
                    text,
                    style: Theme.of(context).textTheme.headlineLarge,
                  ),
                  Text(
                    descriptionText,
                    style: Theme.of(context).textTheme.bodyLarge,
                  )
                ],
              ),
            ),
          ),
          const Spacer(),
          Padding(
            padding: const EdgeInsets.only(left: 8.0),
            child: Icon(icon),
          ),
        ],
      ),
    );
  }
}